Attribute VB_Name = "Module1"
Public Const GENERIC_WRITE = &H40000000
Public Const GENERIC_READ = &H80000000
Const FILE_ATTRIBUTE_NORMAL = &H80
Const CREATE_ALWAYS = 2
Const OPEN_ALWAYS = 4
Const INVALID_HANDLE_VALUE = -1
Const FILE_NAME = "TEST.DAT" 'һļ

Type MyType
value As Integer
End Type

Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, _
        lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, _
        lpNumberOfBytesRead As Long, ByVal lpOverlapped As Long) _
        As Long

Private Declare Function CloseHandle Lib "kernel32" ( _
        ByVal hObject As Long) As Long

Private Declare Function WriteFile Lib "kernel32" ( _
        ByVal hFile As Long, lpBuffer As Any, _
        ByVal nNumberOfBytesToWrite As Long, _
        lpNumberOfBytesWritten As Long, ByVal lpOverlapped As _
        Long) As Long

Private Declare Function CreateFile Lib "kernel32" _
        Alias "CreateFileA" (ByVal lpFileName As String, _
        ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, _
        ByVal lpSecurityAttributes As Long, _
        ByVal dwCreationDisposition As Long, _
        ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile _
        As Long) As Long

Declare Function FlushFileBuffers Lib "kernel32" ( _
        ByVal hFile As Long) As Long

Sub fillArray(anArray() As MyType)
    Dim x As Integer

    For x = 0 To UBound(anArray)
        anArray(x).value = x
    Next x
End Sub

Sub Main()
    Dim fHandle As Integer
    Dim T(1000) As MyType 'һ
    Dim S(1000) As MyType 'һ

    fillArray T '
    writearray FILE_NAME, T 'дļ
    readArray FILE_NAME, S 'һ
End Sub

Sub readArray(Fname As String, anArray() As MyType)
    Dim fHandle As Long
    Dim fSuccess As Long
    Dim sTest As String
    Dim lBytesRead As Long
    Dim BytesToRead As Long

    'ȡݴС
    BytesToRead = (UBound(anArray) + 1) * LenB(anArray(0))
    'ȡ Fname ľ
    fHandle = CreateFile(Fname, GENERIC_WRITE Or GENERIC_READ, _
            0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0)
    'CreateFile ʧܵĻ INVALID_HANDLE_VALUE
    If fHandle <> INVALID_HANDLE_VALUE Then
        fSuccess = ReadFile(fHandle, anArray(LBound(anArray)), _
        BytesToRead, lBytesRead, 0)
        'ReadFile ɹ󷵻һ 0 ֵ
        'رļ
        fSuccess = CloseHandle(fHandle)
    End If
End Sub

Sub writearray(Fname As String, anArray() As MyType)
    Dim fHandle As Long
    Dim fSuccess As Long
    Dim sTest As String
    Dim lBytesWritten As Long
    Dim BytesToWrite As Long
    'ȡݴС
    BytesToWrite = (UBound(anArray) + 1) * LenB(anArray(0))
    'ȡ Fname ľ
    fHandle = CreateFile(Fname, GENERIC_WRITE Or GENERIC_READ, _
        0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0)
    'CreateFile ʧܵĻ INVALID_HANDLE_VALUE
    If fHandle <> INVALID_HANDLE_VALUE Then
        fSuccess = WriteFile(fHandle, anArray(LBound(anArray)), _
        BytesToWrite, lBytesWritten, 0)
        'WriteFile ɹ󷵻һ 0 ֵ
        If fSuccess <> 0 Then
            'ˢļ壬 д
            fSuccess = FlushFileBuffers(fHandle)
            'رļ
            fSuccess = CloseHandle(fHandle)
        End If
    End If
End Sub
